<?php
namespace Teknisa\Logic\SIT\Exception;

class ExceptionDePara extends \Geral\Logic\Exception
{


    private $messageName;
    private $messageNameAcumulado;
    private $paramsAcumulado;


    public function __construct($messagemName, $param = null){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
        $this->addParam($param);
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * Retorna o parametro da mensagem para esta excecao.
     *
     * @return string
     */
    public function getParam()
    {
        return $this->getParams();
    }


    public function acumulaMensagem($NmMensagem, $params){
        $this->messageNameAcumulado = $NmMensagem;
        $this->paramsAcumulado = $params;
    }


    public static function erroInserirDe(){
        throw new self('sit00100_erroInserirDe');
    }


    public static function erroOrgInvalidoDe(){
        throw new self('sit00100_erroOrgInvalidoDe');
    }


    public static function erroListaDeNaoRecon(){
        throw new self('sit00100_erroListaDeNaoRecon');
    }


    public static function erroQtdProdRecebidos($qtdProdsEnvERec){
        throw new self('sit00100_erroQtdProdRecebidos', $qtdProdsEnvERec);
    }




}