-- ================================================================== --
-- SISTEMA         : PONTO DE VENDA                                   --
-- DATA DA CRIAO : INCIO - 05/07/2002                              --
-- CRIAO         : Renata Diniz                                     --
-- OBJETIVOS       : Atualiza os saldos dos consumidores              --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\3840_PDVSTP_Atualiza_Saldo_Cons.sql--
-- ================================================================== --
CREATE OR REPLACE PROCEDURE ATUALIZA_SALDO_CONS(
  P_CDFILIAL     IN MOVICLIE.CDFILIAL%TYPE,
  P_CDCLIENTE    IN MOVICLIE.CDCLIENTE%TYPE,
  P_CDCONSUMIDOR IN MOVICLIE.CDCONSUMIDOR%TYPE,
  P_DATA         IN DATE,
  P_OPERADOR     IN MOVICLIE.CDOPERECSALD%TYPE

 )AS
  V_CDCLIENTE     VARCHAR(21);
  V_CDCONSUMIDOR  VARCHAR(21);
  V_MENORIGUAL    NUMBER;
  V_MAIORIGUAL    NUMBER;
  V_REGMENORIGUAL NUMBER;
  V_DTLANCAMENTO  MOVICLIE.DTMOVCLI%TYPE;
  V_UCONSUMIDOR   VARCHAR(1);
  V_DTMOVCLI      DATE;
  V_VRMOVCLI      NUMBER;
  V_VRMOVPESCONS  NUMBER;
  V_IDTIPMOCVLI   VARCHAR(1);
  V_VRSALDOCONS   NUMBER;
  V_VRSALDPECONS  NUMBER;
  V_VRATUALIZACAO NUMBER;
  V_VRATUALPECONS NUMBER;

BEGIN

   IF P_CDCONSUMIDOR IS NULL THEN
      V_UCONSUMIDOR := 'U';
   ELSE
      V_UCONSUMIDOR := 'X';
   END IF;
   /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
   SELECT
      MIN(DTMOVCLI)
   INTO V_DTLANCAMENTO
   FROM
      MOVICLIE
   WHERE
      (CDCLIENTE       = P_CDCLIENTE   ) AND
      ((CDCONSUMIDOR   = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
       (V_UCONSUMIDOR  = 'U'))) AND
      (DTMOVCLI       >= P_DATA        );

   /*Retorna o nmero de registros menores ou iguais  data/hora informada*/
   SELECT
      COUNT(DTMOVCLI)
   INTO V_REGMENORIGUAL
   FROM
      MOVICLIE
   WHERE
      (CDCLIENTE      = P_CDCLIENTE      ) AND
      ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
       (V_UCONSUMIDOR = 'U'))) AND
      (DTMOVCLI      <= V_DTLANCAMENTO   );

   /*Se a data/hora informada for a primeira o saldo ser atualizado com o valor do prprio lanamento*/
   IF V_REGMENORIGUAL = 1 THEN

      /*Seleciona o lanamento*/
      SELECT
         DTMOVCLI,VRMOVCLI,VRMOVPESCONS,IDTIPMOCVLI,VRSALDOCONS,VRSALDPECONS
      INTO V_DTMOVCLI, V_VRMOVCLI, V_VRMOVPESCONS, V_IDTIPMOCVLI, V_VRSALDOCONS, V_VRSALDPECONS
      FROM
         MOVICLIE
      WHERE
         (CDCLIENTE      = P_CDCLIENTE      ) AND
         ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
          (V_UCONSUMIDOR = 'U'))) AND
         (DTMOVCLI       = V_DTLANCAMENTO   )
      ORDER BY
         DTMOVCLI;

      IF V_IDTIPMOCVLI = 'D' THEN
         V_VRMOVCLI      := (-1) * V_VRMOVCLI;
         V_VRMOVPESCONS  := (-1) * V_VRMOVPESCONS;
      ELSIF V_IDTIPMOCVLI = 'A' THEN
         V_VRMOVCLI      := 0;
         V_VRMOVPESCONS  := 0;
      ELSIF V_IDTIPMOCVLI = 'X' THEN
         V_VRMOVCLI      := 0;
         V_VRMOVPESCONS  := 0;
      END IF;

      /*Grava no valor do saldo, o valor da movimentao, visto que no h lanamento anterior*/
      UPDATE
         MOVICLIE
      SET
         VRSALDOCONS  = V_VRMOVCLI,
         VRSALDPECONS = V_VRMOVPESCONS,
         CDOPERECSALD = P_OPERADOR,
         DTRECMOVCLIE = SYSDATE
      WHERE
         (CDCLIENTE      = P_CDCLIENTE      ) AND
         ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND (V_UCONSUMIDOR = 'U'))) AND
         (DTMOVCLI       = V_DTLANCAMENTO   );

      /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
      SELECT
         COUNT(DTMOVCLI)
      INTO V_MAIORIGUAL
      FROM
         MOVICLIE
      WHERE
         (CDCLIENTE     = P_CDCLIENTE      ) AND
         ((CDCONSUMIDOR = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
          (V_UCONSUMIDOR = 'U'))) AND
         (DTMOVCLI     >= V_DTLANCAMENTO   );
      /*Atualiza lanamentos posteriores*/
      IF V_MAIORIGUAL > 1 THEN
         FOR CUR_MOVICLIE IN (
            SELECT
               DTMOVCLI,VRMOVCLI,VRMOVPESCONS,IDTIPMOCVLI,VRSALDOCONS,VRSALDPECONS
            FROM
               MOVICLIE
            WHERE
               (CDCLIENTE     = P_CDCLIENTE      ) AND
               ((CDCONSUMIDOR = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                (V_UCONSUMIDOR = 'U'))) AND
               (DTMOVCLI     >= V_DTMOVCLI   )
            ORDER BY
               DTMOVCLI
         ) LOOP

            V_VRMOVCLI     := CUR_MOVICLIE.VRMOVCLI;
            V_VRMOVPESCONS := CUR_MOVICLIE.VRMOVPESCONS;

            IF CUR_MOVICLIE.IDTIPMOCVLI = 'D' THEN
               V_VRMOVCLI     := (-1) * CUR_MOVICLIE.VRMOVCLI;
               V_VRMOVPESCONS := (-1) * CUR_MOVICLIE.VRMOVPESCONS;
            ELSIF CUR_MOVICLIE.IDTIPMOCVLI = 'X' THEN
               V_VRMOVCLI     := 0;
               V_VRMOVPESCONS := 0;
            END IF;

            /*raise_application_error(-20504, CUR_MOVICLIE.DTMOVCLI, True);*/

            /*Retorna o saldo imediatamente anterior*/
            SELECT
               (NVL(MAX(VRSALDOCONS),0)  + V_VRMOVCLI)   ,
               (NVL(MAX(VRSALDPECONS),0) + V_VRMOVPESCONS)
            INTO V_VRATUALIZACAO, V_VRATUALPECONS
            FROM
               MOVICLIE
            WHERE
               (CDCLIENTE      = P_CDCLIENTE      ) AND
               ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                (V_UCONSUMIDOR = 'U'))) AND
               (DTMOVCLI       = (SELECT
                                   MAX(DTMOVCLI)
                                FROM
                                   MOVICLIE
                                WHERE
                                   (CDCLIENTE     = P_CDCLIENTE      ) AND
                                   ((CDCONSUMIDOR = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                                    (V_UCONSUMIDOR = 'U'))) AND
                                   (DTMOVCLI      < CUR_MOVICLIE.DTMOVCLI        )
                               )
               );

            IF CUR_MOVICLIE.IDTIPMOCVLI = 'A' THEN
               V_VRATUALIZACAO := 0;
            END IF;

            /*Atualiza os lanamentos*/
            UPDATE
               MOVICLIE
            SET
               VRSALDOCONS  = V_VRATUALIZACAO,
               VRSALDPECONS = V_VRATUALPECONS,
               CDOPERECSALD = P_OPERADOR,
               DTRECMOVCLIE = SYSDATE
            WHERE
               (CDCLIENTE      = P_CDCLIENTE      ) AND
               ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                (V_UCONSUMIDOR = 'U'))) AND
               (DTMOVCLI       = CUR_MOVICLIE.DTMOVCLI);

         END LOOP;
      END IF;
   END IF;
   IF V_REGMENORIGUAL > 1 THEN
      /*Seleciona os lanamentos a partir do atual.*/
      FOR CUR_MOVICLIE IN (
         SELECT
            DTMOVCLI,VRMOVCLI,VRMOVPESCONS,IDTIPMOCVLI,VRSALDOCONS,VRSALDPECONS
         FROM
            MOVICLIE
         WHERE
            (CDCLIENTE     = P_CDCLIENTE      ) AND
            ((CDCONSUMIDOR = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
             (V_UCONSUMIDOR = 'U'))) AND
            (DTMOVCLI     >= V_DTLANCAMENTO   )
         ORDER BY
            DTMOVCLI
      ) LOOP

         /*qrySaldoAnte*/
         V_VRMOVCLI     := CUR_MOVICLIE.VRMOVCLI;
         V_VRMOVPESCONS := CUR_MOVICLIE.VRMOVPESCONS;

         IF CUR_MOVICLIE.IDTIPMOCVLI = 'D' THEN
            V_VRMOVCLI     := (-1) * CUR_MOVICLIE.VRMOVCLI;
            V_VRMOVPESCONS := (-1) * CUR_MOVICLIE.VRMOVPESCONS;
         ELSIF CUR_MOVICLIE.IDTIPMOCVLI = 'X' THEN
            V_VRMOVCLI     := 0;
            V_VRMOVPESCONS := 0;
         END IF;

         SELECT
            (NVL(MAX(VRSALDOCONS),0)  + V_VRMOVCLI)   AS VRATUALIZACAO,
            (NVL(MAX(VRSALDPECONS),0) + V_VRMOVPESCONS) AS VRATUALPECONS
         INTO V_VRATUALIZACAO, V_VRATUALPECONS
         FROM
            MOVICLIE
         WHERE
            (CDCLIENTE      = P_CDCLIENTE      ) AND
            ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
             (V_UCONSUMIDOR = 'U'))) AND
            (DTMOVCLI       = (SELECT
                                 MAX(DTMOVCLI)
                              FROM
                                 MOVICLIE
                              WHERE
                                 (CDCLIENTE     = P_CDCLIENTE      ) AND
                                 ((CDCONSUMIDOR = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                                  (V_UCONSUMIDOR = 'U'))) AND
                                 (DTMOVCLI       < CUR_MOVICLIE.DTMOVCLI       )
                             )
            );

         IF CUR_MOVICLIE.IDTIPMOCVLI = 'A' THEN
            V_VRATUALIZACAO := 0;
         END IF;

         /*qryAtualiza*/
         UPDATE
            MOVICLIE
         SET
            VRSALDOCONS  = V_VRATUALIZACAO,
            VRSALDPECONS = V_VRATUALPECONS,
            CDOPERECSALD = P_OPERADOR,
            DTRECMOVCLIE = SYSDATE
         WHERE
            (CDCLIENTE      = P_CDCLIENTE   ) AND
            ((CDCONSUMIDOR  = P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
             (V_UCONSUMIDOR = 'U'))) AND
            (DTMOVCLI       = CUR_MOVICLIE.DTMOVCLI);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_SALDO_CONS','4.05.136'); END;
/

