/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3914_CDPSTP0.SQL

Descrio:
Exclui MRP.

P_CDFILIAL  - Cdigo da Filial a ser gerado o MRP.
P_DTMRP     - Data da Gerao do MRP.

Criao:
18/10/2004 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DEL_MRP'  and
            type = 'P'          and
            u.uid = o.uid       and
            u.name = USER)
  DROP PROCEDURE DEL_MRP
  GO

CREATE PROCEDURE DEL_MRP
   @P_CDFILIAL  VARCHAR(4),
   @P_DTMRP     DATETIME
AS
BEGIN

   DELETE FROM PEDIDOMRP
   WHERE CDFILIAL     = @P_CDFILIAL  AND
         (CONVERT(VARCHAR,DTHRPEDIDOMRP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
         (CONVERT(VARCHAR,DTHRPEDIDOMRP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108));

   DELETE FROM SOLICITAMRP
   WHERE CDFILIAL     = @P_CDFILIAL  AND
         (CONVERT(VARCHAR,DTHRSOLICITAMRP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
         (CONVERT(VARCHAR,DTHRSOLICITAMRP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108));

   DELETE FROM PREMATPPROGP
   WHERE CDFILIAL     = @P_CDFILIAL  AND
         (CONVERT(VARCHAR,DTPROGPRODMP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
         (CONVERT(VARCHAR,DTPROGPRODMP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108));

   DELETE FROM CALENDEQUIPAPRO
   WHERE CDFILIAL = @P_CDFILIAL AND
        (CONVERT(VARCHAR,DTPROGUTEQUIP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
        (CONVERT(VARCHAR,DTPROGUTEQUIP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108));

   DELETE FROM CALEPRODMRP
   WHERE CDFILIAL     = @P_CDFILIAL  AND
         (CONVERT(VARCHAR,DTPROGPRODCP,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
         (CONVERT(VARCHAR,DTPROGPRODCP,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108));


   DELETE FROM PROGPRODU
   WHERE CDFILIAL     = @P_CDFILIAL  AND
         (CONVERT(VARCHAR,DTPROGPRODU,103) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),103)) AND
         (CONVERT(VARCHAR,DTPROGPRODU,108) = CONVERT(VARCHAR, CONVERT(DATETIME,@P_DTMRP),108));
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'DEL_MRP','5.05.016';
GO

